import os 
import re 
from tqdm import tqdm 
from pdfminer.pdfparser import  PDFParser,PDFDocument
from pdfminer.pdfinterp import PDFResourceManager, PDFPageInterpreter
from pdfminer.converter import PDFPageAggregator
from pdfminer.layout import LTTextBoxHorizontal,LAParams
from pdfminer.pdfinterp import PDFTextExtractionNotAllowed

def pdf_parse(pdf_path,txt_path):
    '''解析PDF文本，并保存到TXT文件中'''
    fp = open(pdf_path,'rb')
    # pdf1 = urlopen('http://www.tencent.com/20160321.pdf')
    #用文件对象创建一个PDF文档分析器
    parser = PDFParser(fp)
    #创建一个PDF文档
    doc = PDFDocument()
    #连接分析器，与文档对象
    parser.set_document(doc)
    doc.set_parser(parser)

    #提供初始化密码，如果没有密码，就创建一个空的字符串
    doc.initialize()

    #检测文档是否提供txt转换，不提供就忽略
    if not doc.is_extractable:
        print(pdf_path)
        raise PDFTextExtractionNotAllowed
    else:
        #创建PDF，资源管理器，来共享资源
        rsrcmgr = PDFResourceManager()
        #创建一个PDF设备对象
        laparams = LAParams()
        device = PDFPageAggregator(rsrcmgr,laparams=laparams)
        #创建一个PDF解释其对象
        interpreter = PDFPageInterpreter(rsrcmgr,device)

        #循环遍历列表，每次处理一个page内容
        # doc.get_pages() 获取page列表
        for page in doc.get_pages():
            interpreter.process_page(page)
            #接受该页面的LTPage对象
            layout = device.get_result()
            # 这里layout是一个LTPage对象 里面存放着 这个page解析出的各种对象
            # 一般包括LTTextBox, LTFigure, LTImage, LTTextBoxHorizontal 等等
            # 想要获取文本就获得对象的text属性，
            for x in layout:
                if(isinstance(x,LTTextBoxHorizontal)):
                    with open(txt_path,'a') as f:
                        results = x.get_text()
                        # print(results)
                        f.write(results  +"\n")


if __name__ == '__main__':
    open_pdf_path = '/Users/zhengfei/Desktop/科润智控.pdf'  #【设定打开pdf文件路径】
    save_txt_path = '/Users/zhengfei/Desktop/'   #【设定保存TXT文件路径】
    pdfList = os.listdir(open_pdf_path)
    for pdf_name in tqdm(pdfList):   
        try:
            format = pdf_name.split(".")[1]
            if format=="pdf":
                pdf_path = open_pdf_path+pdf_name 
                txt_name = re.sub('.pdf', '.txt', pdf_name) 
            elif format=="PDF":
                pdf_path = open_pdf_path+pdf_name 
                txt_name = re.sub('.PDF', '.txt', pdf_name)
            txt_path = save_txt_path+txt_name
            pdf_parse(pdf_path, txt_path)
        except:
            print("转换失败：", pdf_name)
            continue